package se.softstuff.nb.bundleeditor;

import java.beans.PropertyVetoException;
import java.io.IOException;
import javax.swing.*;
import org.apache.log4j.Logger;
import org.netbeans.core.spi.multiview.CloseOperationState;
import org.netbeans.core.spi.multiview.MultiViewElement;
import org.netbeans.core.spi.multiview.MultiViewElementCallback;
import org.openide.awt.UndoRedo;
import org.openide.cookies.SaveCookie;
import org.openide.explorer.ExplorerManager;
import org.openide.explorer.ExplorerUtils;
import org.openide.explorer.view.BeanTreeView;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.util.Exceptions;
import org.openide.util.Lookup;
import org.openide.util.NbBundle;
import org.openide.util.lookup.Lookups;
import org.openide.util.lookup.ProxyLookup;
import org.openide.windows.TopComponent;
import se.softstuff.nb.domain.NbBundleDiff;
import se.softstuff.nb.domain.NbBundleDiffDataObject;
import se.softstuff.nb.domain.node.BundleNode;
import se.softstuff.nb.domain.node.TranslateProjectNode;
import se.softstuff.nb.domain.tracer.DontMarkThisComponent;

@MultiViewElement.Registration(displayName = "#LBL_NbBundleEdit_MANAGER",
iconBase = "se/softstuff/nb/domain/nb_translate.png",
mimeType = "text/nb-bundle-diff+xml",
persistenceType = TopComponent.PERSISTENCE_NEVER,
preferredID = "NbBundleEditManager",
position = 2000)
public final class NbBundleEditManagerElement extends JPanel implements MultiViewElement, ExplorerManager.Provider, DontMarkThisComponent {

    private Logger log = Logger.getLogger(NbBundleEditManagerElement.class);
    private ExplorerManager manager;
    private Lookup lookup;
    private Lookup lookupIn;
    private JToolBar toolbar = new JToolBar();
    private transient MultiViewElementCallback callback;
//    private ChangedBundleFactory childFactory;

//    public NbBundleEditManagerElement() {
//        this(Lookup.getDefault());
//    }
    public NbBundleEditManagerElement(Lookup lkp) {
        log.debug("create NbBundleEditManagerElement");
        lookupIn = lkp;
        initComponents();

        model.setup(lkp);

        manager = new ExplorerManager();
        ActionMap map = getActionMap();

        NbBundleDiffDataObject dataObject = lkp.lookup(NbBundleDiffDataObject.class);
        NbBundleDiff content = dataObject.getContent();
        
        Lookup contentLookup = Lookups.singleton(content);
//        Lookup nodeLookup = new ProxyLookup(dataObject.getLookup(), Lookups.singleton(content));
        lookup = new ProxyLookup(ExplorerUtils.createLookup(manager, map), contentLookup);

//        childFactory = new ChangedBundleFactory();

         Node rootNode = new TranslateProjectNode(contentLookup);

//         rootNode = new BundleNode(
//                 "se.databyran.prosang.client.donor.administration.information.general.Bundle_sv_SE.properties",
//                 "se-databyran-prosang-client-donor-administration",
//         Lookups.singleton(content));
//         rootNode = new AbstractNode(Children.LEAF, lkp);

            manager.setRootContext(rootNode);
        try {
            manager.setSelectedNodes(new Node[]{rootNode});
        } catch (PropertyVetoException ex) {
            Exceptions.printStackTrace(ex);
        }
            ((BeanTreeView) changesTreePane).setRootVisible(true);
            
//        fillTree();
    }

    private void fillTree() {
        try {

            TranslateProjectNode node = new TranslateProjectNode(lookup);

            Node rootNode = createProjectNode();
//.getNodeDelegate();
//                    createProjectNode();
//                    new AbstractNode(Children.create(childFactory, true));

            manager.setRootContext(rootNode);
            manager.setSelectedNodes(new Node[]{rootNode});
            ((BeanTreeView) changesTreePane).setRootVisible(false);

        } catch (PropertyVetoException ex) {
            Exceptions.printStackTrace(ex);
        }
    }
    
    public TranslateProjectNode createProjectNode() {

//        }
            TranslateProjectNode node = new TranslateProjectNode(lookup);
//        }
        return node;
    }

    @Override
    public String getName() {
        return "NbBundleEditManagerElement";
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        model = new se.softstuff.nb.bundleeditor.NbBundleEditVisualElementPresentationModel();
        jPanel1 = new javax.swing.JPanel();
        startEditButton = new javax.swing.JButton();
        saveButton = new javax.swing.JButton();
        startLabel = new javax.swing.JLabel();
        saveLabel = new javax.swing.JLabel();
        changesTreePane = new BeanTreeView();

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(NbBundle.getMessage(NbBundleEditManagerElement.class, "NbBundleEditManagerlElement.jPanel1.border.title"))); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(startEditButton, NbBundle.getMessage(NbBundleEditManagerElement.class, "NbBundleEditManagerlElement.startEditButton.text")); // NOI18N
        startEditButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                startEditButtonActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(saveButton, NbBundle.getMessage(NbBundleEditManagerElement.class, "NbBundleEditManagerlElement.saveButton.text")); // NOI18N
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(startLabel, NbBundle.getMessage(NbBundleEditManagerElement.class, "NbBundleEditManagerlElement.startLabel.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(saveLabel, NbBundle.getMessage(NbBundleEditManagerElement.class, "NbBundleEditManagerlElement.saveLabel.text")); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(startLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 164, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(startEditButton)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(saveLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(saveButton)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(startEditButton)
                    .addComponent(startLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(saveButton)
                    .addComponent(saveLabel))
                .addGap(30, 30, 30))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(changesTreePane)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 590, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(changesTreePane, javax.swing.GroupLayout.DEFAULT_SIZE, 163, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void startEditButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startEditButtonActionPerformed
        try {
            NbBundleEditManager bundleManager = NbBundleEditManager.getInstance();
            if (bundleManager.isAttached()) {
                bundleManager.detach();
            } else {
                bundleManager.attach(model.getData());
            }
            updateStartButtonLabel();
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
    }//GEN-LAST:event_startEditButtonActionPerformed

    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
        try {
            getLookup().lookup(SaveCookie.class).save();
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
    }//GEN-LAST:event_saveButtonActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane changesTreePane;
    private javax.swing.JPanel jPanel1;
    private se.softstuff.nb.bundleeditor.NbBundleEditVisualElementPresentationModel model;
    private javax.swing.JButton saveButton;
    private javax.swing.JLabel saveLabel;
    private javax.swing.JButton startEditButton;
    private javax.swing.JLabel startLabel;
    // End of variables declaration//GEN-END:variables

    @Override
    public JComponent getVisualRepresentation() {
        log.debug("getVisualRepresentation");
        return this;
    }

    @Override
    public JComponent getToolbarRepresentation() {
        log.debug("getToolbarRepresentation");
        return toolbar;
    }

    @Override
    public Action[] getActions() {
        if (callback != null) {
            return callback.createDefaultActions();
        }
        return new Action[0];
    }

    @Override
    public Lookup getLookup() {
        return lookup;
//        return model.getLookup();
    }

    @Override
    public void componentOpened() {
        log.debug("componentOpened");
//        TracerManager tracer = getTracer();
//        tracer.attachTrigger(model.getStartTrigger());
    }

    @Override
    public void componentClosed() {
        log.debug("componentClosed");
//        model.saveTriggers();
//        TracerManager tracer = getTracer();
//        tracer.detatchTrigger();
    }

    @Override
    public void componentShowing() {
        log.debug("componentShowing");
    }

    @Override
    public void componentHidden() {
        log.debug("componentHidden");
    }

    @Override
    public void componentActivated() {
        log.debug("componentActivated");
    }

    @Override
    public void componentDeactivated() {
        log.debug("componentDeactivated");
    }

    @Override
    public UndoRedo getUndoRedo() {
        return UndoRedo.NONE;
    }

    @Override
    public void setMultiViewCallback(MultiViewElementCallback callback) {
        this.callback = callback;
        log.debug("setMultiViewCallback");
    }

    @Override
    public CloseOperationState canCloseElement() {
        return CloseOperationState.STATE_OK;
    }

    private void updateStartButtonLabel() {

        String key = String.format("NbBundleEditManagerlElement.startEditButton.%stext",
                (NbBundleEditManager.getInstance().isAttached() ? "stop." : ""));
        String title = NbBundle.getMessage(NbBundleEditManagerElement.class, key);
        startEditButton.setText(title);
    }

//    private TracerManager getTracer() {
//        return Lookup.getDefault().lookup(TracerManager.class);
//    }

    @Override
    public ExplorerManager getExplorerManager() {
        return manager;
    }

}
